//>>built
define("dojo/data/ItemFileReadStore",["../_base/kernel","../_base/lang","../_base/declare","../_base/array","../_base/xhr","../Evented","./util/filter","./util/simpleFetch","../date/stamp"],function(e,r,a,t,i,d,l,o,n){var s=a("dojo.data.ItemFileReadStore",[d],{constructor:function(e){this._arrayOfAllItems=[],this._arrayOfTopLevelItems=[],this._loadFinished=!1,this._jsonFileUrl=e.url,this._ccUrl=e.url,this.url=e.url,this._jsonData=e.data,this.data=null,this._datatypeMap=e.typeMap||{},this._datatypeMap.Date||(this._datatypeMap.Date={type:Date,deserialize:function(e){return n.fromISOString(e)}}),this._features={"dojo.data.api.Read":!0,"dojo.data.api.Identity":!0},this._itemsByIdentity=null,this._storeRefPropName="_S",this._itemNumPropName="_0",this._rootItemPropName="_RI",this._reverseRefMap="_RRM",this._loadInProgress=!1,this._queuedFetches=[],void 0!==e.urlPreventCache&&(this.urlPreventCache=!!e.urlPreventCache),void 0!==e.hierarchical&&(this.hierarchical=!!e.hierarchical),e.clearOnClose&&(this.clearOnClose=!0),"failOk"in e&&(this.failOk=!!e.failOk)},url:"",_ccUrl:"",data:null,typeMap:null,clearOnClose:!1,urlPreventCache:!1,failOk:!1,hierarchical:!0,_assertIsItem:function(e){if(!this.isItem(e))throw new Error(this.declaredClass+": Invalid item argument.")},_assertIsAttribute:function(e){if("string"!=typeof e)throw new Error(this.declaredClass+": Invalid attribute argument.")},getValue:function(e,r,a){var t=this.getValues(e,r);return t.length>0?t[0]:a},getValues:function(e,r){return this._assertIsItem(e),this._assertIsAttribute(r),(e[r]||[]).slice(0)},getAttributes:function(e){this._assertIsItem(e);var r=[];for(var a in e)a!==this._storeRefPropName&&a!==this._itemNumPropName&&a!==this._rootItemPropName&&a!==this._reverseRefMap&&r.push(a);return r},hasAttribute:function(e,r){return this._assertIsItem(e),this._assertIsAttribute(r),r in e},containsValue:function(e,r,a){var t=void 0;return"string"==typeof a&&(t=l.patternToRegExp(a,!1)),this._containsValue(e,r,a,t)},_containsValue:function(e,a,i,d){return t.some(this.getValues(e,a),function(e){if(null!==e&&!r.isObject(e)&&d){if(e.toString().match(d))return!0}else if(i===e)return!0})},isItem:function(e){return!(!e||e[this._storeRefPropName]!==this||this._arrayOfAllItems[e[this._itemNumPropName]]!==e)},isItemLoaded:function(e){return this.isItem(e)},loadItem:function(e){this._assertIsItem(e.item)},getFeatures:function(){return this._features},getLabel:function(e){if(this._labelAttr&&this.isItem(e))return this.getValue(e,this._labelAttr)},getLabelAttributes:function(e){return this._labelAttr?[this._labelAttr]:null},filter:function(e,r,a){var t,i,d=[];if(e.query){var o,n=!!e.queryOptions&&e.queryOptions.ignoreCase,s={};for(i in e.query)o=e.query[i],"string"==typeof o?s[i]=l.patternToRegExp(o,n):o instanceof RegExp&&(s[i]=o);for(t=0;t<r.length;++t){var f=!0,m=r[t];if(null===m)f=!1;else for(i in e.query)o=e.query[i],this._containsValue(m,i,o,s[i])||(f=!1);f&&d.push(m)}a(d,e)}else{for(t=0;t<r.length;++t){var v=r[t];null!==v&&d.push(v)}a(d,e)}},_fetchItems:function(a,t,d){var l=this;if(this._loadFinished)this.filter(a,this._getItemsArray(a.queryOptions),t);else if(this._jsonFileUrl!==this._ccUrl?(e.deprecated(this.declaredClass+": ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this._ccUrl=this._jsonFileUrl,this.url=this._jsonFileUrl):this.url!==this._ccUrl&&(this._jsonFileUrl=this.url,this._ccUrl=this.url),null!=this.data&&(this._jsonData=this.data,this.data=null),this._jsonFileUrl)if(this._loadInProgress)this._queuedFetches.push({args:a,filter:r.hitch(l,"filter"),findCallback:r.hitch(l,t)});else{this._loadInProgress=!0;var o={url:l._jsonFileUrl,handleAs:"json-comment-optional",preventCache:this.urlPreventCache,failOk:this.failOk},n=i.get(o);n.addCallback(function(e){try{l._getItemsFromLoadedData(e),l._loadFinished=!0,l._loadInProgress=!1,l.filter(a,l._getItemsArray(a.queryOptions),t),l._handleQueuedFetches()}catch(e){l._loadFinished=!0,l._loadInProgress=!1,d(e,a)}}),n.addErrback(function(e){l._loadInProgress=!1,d(e,a)});var s=null;a.abort&&(s=a.abort),a.abort=function(){var e=n;e&&-1===e.fired&&(e.cancel(),e=null),s&&s.call(a)}}else if(this._jsonData)try{this._loadFinished=!0,this._getItemsFromLoadedData(this._jsonData),this._jsonData=null,l.filter(a,this._getItemsArray(a.queryOptions),t)}catch(e){d(e,a)}else d(new Error(this.declaredClass+": No JSON source data was provided as either URL or a nested Javascript object."),a)},_handleQueuedFetches:function(){if(this._queuedFetches.length>0){for(var e=0;e<this._queuedFetches.length;e++){var r=this._queuedFetches[e],a=r.args,t=r.filter,i=r.findCallback;t?t(a,this._getItemsArray(a.queryOptions),i):this.fetchItemByIdentity(a)}this._queuedFetches=[]}},_getItemsArray:function(e){return e&&e.deep?this._arrayOfAllItems:this._arrayOfTopLevelItems},close:function(e){this.clearOnClose&&this._loadFinished&&!this._loadInProgress&&(""!=this._jsonFileUrl&&null!=this._jsonFileUrl||""!=this.url&&null!=this.url||this.data,this._arrayOfAllItems=[],this._arrayOfTopLevelItems=[],this._loadFinished=!1,this._itemsByIdentity=null,this._loadInProgress=!1,this._queuedFetches=[])},_getItemsFromLoadedData:function(e){function a(e){return null!==e&&"object"==typeof e&&(!r.isArray(e)||i)&&!r.isFunction(e)&&(e.constructor==Object||r.isArray(e))&&void 0===e._reference&&void 0===e._type&&void 0===e._value&&d.hierarchical}function t(e){d._arrayOfAllItems.push(e);for(var i in e){var l=e[i];if(l)if(r.isArray(l))for(var o=l,n=0;n<o.length;++n){var s=o[n];a(s)&&t(s)}else a(l)&&t(l)}}var i=!1,d=this;this._labelAttr=e.label;var l,o;for(this._arrayOfAllItems=[],this._arrayOfTopLevelItems=e.items,l=0;l<this._arrayOfTopLevelItems.length;++l)o=this._arrayOfTopLevelItems[l],r.isArray(o)&&(i=!0),t(o),o[this._rootItemPropName]=!0;var n,s={};for(l=0;l<this._arrayOfAllItems.length;++l){o=this._arrayOfAllItems[l];for(n in o){if(n!==this._rootItemPropName){var f=o[n];null!==f?r.isArray(f)||(o[n]=[f]):o[n]=[null]}s[n]=n}}for(;s[this._storeRefPropName];)this._storeRefPropName+="_";for(;s[this._itemNumPropName];)this._itemNumPropName+="_";for(;s[this._reverseRefMap];)this._reverseRefMap+="_";var m,v=e.identifier;if(v)for(this._itemsByIdentity={},this._features["dojo.data.api.Identity"]=v,l=0;l<this._arrayOfAllItems.length;++l){o=this._arrayOfAllItems[l],m=o[v];var u=m[0];if(Object.hasOwnProperty.call(this._itemsByIdentity,u)){if(this._jsonFileUrl)throw new Error(this.declaredClass+":  The json data as specified by: ["+this._jsonFileUrl+"] is malformed.  Items within the list have identifier: ["+v+"].  Value collided: ["+u+"]");if(this._jsonData)throw new Error(this.declaredClass+":  The json data provided by the creation arguments is malformed.  Items within the list have identifier: ["+v+"].  Value collided: ["+u+"]")}else this._itemsByIdentity[u]=o}else this._features["dojo.data.api.Identity"]=Number;for(l=0;l<this._arrayOfAllItems.length;++l)o=this._arrayOfAllItems[l],o[this._storeRefPropName]=this,o[this._itemNumPropName]=l;for(l=0;l<this._arrayOfAllItems.length;++l){o=this._arrayOfAllItems[l];for(n in o){m=o[n];for(var h=0;h<m.length;++h)if(null!==(f=m[h])&&"object"==typeof f){if("_type"in f&&"_value"in f){var y=f._type,w=this._datatypeMap[y];if(!w)throw new Error("dojo.data.ItemFileReadStore: in the typeMap constructor arg, no object class was specified for the datatype '"+y+"'");if(r.isFunction(w))m[h]=new w(f._value);else{if(!r.isFunction(w.deserialize))throw new Error("dojo.data.ItemFileReadStore: Value provided in typeMap was neither a constructor, nor a an object with a deserialize function");m[h]=w.deserialize(f._value)}}if(f._reference){var M=f._reference;if(r.isObject(M))for(var c=0;c<this._arrayOfAllItems.length;++c){var k=this._arrayOfAllItems[c],g=!0;for(var p in M)k[p]!=M[p]&&(g=!1);g&&(m[h]=k)}else m[h]=this._getItemByIdentity(M);if(this.referenceIntegrity){var b=m[h];this.isItem(b)&&this._addReferenceToMap(b,o,n)}}else this.isItem(f)&&this.referenceIntegrity&&this._addReferenceToMap(f,o,n)}}}},_addReferenceToMap:function(e,r,a){},getIdentity:function(e){var r=this._features["dojo.data.api.Identity"];if(r===Number)return e[this._itemNumPropName];var a=e[r];return a?a[0]:null},fetchItemByIdentity:function(r){var a,t;if(this._loadFinished)a=this._getItemByIdentity(r.identity),r.onItem&&(t=r.scope?r.scope:e.global,r.onItem.call(t,a));else{var d=this;if(this._jsonFileUrl!==this._ccUrl?(e.deprecated(this.declaredClass+": ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this._ccUrl=this._jsonFileUrl,this.url=this._jsonFileUrl):this.url!==this._ccUrl&&(this._jsonFileUrl=this.url,this._ccUrl=this.url),null!=this.data&&null==this._jsonData&&(this._jsonData=this.data,this.data=null),this._jsonFileUrl)if(this._loadInProgress)this._queuedFetches.push({args:r});else{this._loadInProgress=!0;var l={url:d._jsonFileUrl,handleAs:"json-comment-optional",preventCache:this.urlPreventCache,failOk:this.failOk},o=i.get(l);o.addCallback(function(t){var i=r.scope?r.scope:e.global;try{d._getItemsFromLoadedData(t),d._loadFinished=!0,d._loadInProgress=!1,a=d._getItemByIdentity(r.identity),r.onItem&&r.onItem.call(i,a),d._handleQueuedFetches()}catch(e){d._loadInProgress=!1,r.onError&&r.onError.call(i,e)}}),o.addErrback(function(a){if(d._loadInProgress=!1,r.onError){var t=r.scope?r.scope:e.global;r.onError.call(t,a)}})}else this._jsonData&&(d._getItemsFromLoadedData(d._jsonData),d._jsonData=null,d._loadFinished=!0,a=d._getItemByIdentity(r.identity),r.onItem&&(t=r.scope?r.scope:e.global,r.onItem.call(t,a)))}},_getItemByIdentity:function(e){var r=null;return this._itemsByIdentity?Object.hasOwnProperty.call(this._itemsByIdentity,e)&&(r=this._itemsByIdentity[e]):Object.hasOwnProperty.call(this._arrayOfAllItems,e)&&(r=this._arrayOfAllItems[e]),void 0===r&&(r=null),r},getIdentityAttributes:function(e){var r=this._features["dojo.data.api.Identity"];return r===Number?null:[r]},_forceLoad:function(){var r=this;if(this._jsonFileUrl!==this._ccUrl?(e.deprecated(this.declaredClass+": ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this._ccUrl=this._jsonFileUrl,this.url=this._jsonFileUrl):this.url!==this._ccUrl&&(this._jsonFileUrl=this.url,this._ccUrl=this.url),null!=this.data&&(this._jsonData=this.data,this.data=null),this._jsonFileUrl){var a={url:this._jsonFileUrl,handleAs:"json-comment-optional",preventCache:this.urlPreventCache,failOk:this.failOk,sync:!0},t=i.get(a);t.addCallback(function(e){try{if(!0===r._loadInProgress||r._loadFinished){if(r._loadInProgress)throw new Error(this.declaredClass+":  Unable to perform a synchronous load, an async load is in progress.")}else r._getItemsFromLoadedData(e),r._loadFinished=!0}catch(e){throw e}}),t.addErrback(function(e){throw e})}else this._jsonData&&(r._getItemsFromLoadedData(r._jsonData),r._jsonData=null,r._loadFinished=!0)}});return r.extend(s,o),s});//# sourceMappingURL=ItemFileReadStore.js.map